//-----------------------------------------------------------------------------
// Torque Game Engine
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------
// Player Sounds
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Players
//-----------------------------------------------------------------------------
datablock PlayerData(SquirrelPlayerData : DefaultPlayerData)
{
   shapeFile = "art/shapes/actors/Squirrel/Squirrel.dae";
   renderFirstPerson = true;
      
   minImpactSpeed = 14;
   speedDamageScale = 1.70;
   
   // First person arms
   //imageAnimPrefixFP = "squirrel";
   //shapeNameFP[0] = "art/shapes/actors/Squirrel/FP_Squirrel.dae";
   
   //Death Sounds
   Death1Sound = SquirrelDeath1;  
   Death2Sound = SquirrelDeath1;  
   Death3Sound = SquirrelDeath1;  
   Death4Sound = SquirrelDeath1;  
   Death5Sound = SquirrelDeath1;  
   Death6Sound = SquirrelDeath1;  
   Death7Sound = SquirrelDeath1; 
   
   //Pain Sounds
   Pain1Sound = SquirrelPain1;   
   Pain2Sound = SquirrelPain2;   
   Pain3Sound = SquirrelPain3;  
   Pain4Sound = SquirrelPain4;   
   Pain5Sound = SquirrelPain5;   
   Pain6Sound = SquirrelPain6;  
   Pain7Sound = SquirrelPain6;  
   
   //maxInv[Flag2] = 1;
   maxInv[SquirrelFlag] = 1;
   
   //AI Variables
   Weapon = "Rifle"; //Starting Weapon
   respawn = true;
   behavior = "ChaseBehavior";
   maxRange = 25;
   minRange = 0;
   distDetect = 50;
   sidestepDist = 10;
   paceDist = 6;
   npcAction = 0;
   spawnGroup = 1;
   fov = 200;
   leash = 35;
   cycleCounter = "5";
   weaponMode = "pattern";
   activeDodge = 1;
   advancedDodge = "Random";
   team = 1;
   realName = "Squirrel Bot";
   countRespawn = 0;
};

PlayerDatasGroup.add(SquirrelPlayerData);

datablock PlayerData(TediPlayerData : DefaultPlayerData)
{
   shapeFile  = "art/shapes/actors/Tedi/Tedi.dae";
   
   //Death Sounds
   Death1Sound = TediDeath1;  
   Death2Sound = TediDeath2;  
   Death3Sound = TediDeath3;  
   Death4Sound = TediDeath4;  
   Death5Sound = TediDeath5;  
   Death6Sound = TediDeath6;  
   Death7Sound = TediDeath7; 
   
   //Pain Sounds
   Pain1Sound = TediPain1;   
   Pain2Sound = TediPain2;   
   Pain3Sound = TediPain3;  
   Pain4Sound = TediPain4;   
   Pain5Sound = TediPain5;   
   Pain6Sound = TediPain6;  
   
   minImpactSpeed = 15;
   speedDamageScale = 0.05;
   
   //maxInv[Flag1] = 1;
   maxInv[TediFlag] = 1;
   
   //AI Variables
   Weapon = "Rifle"; //Starting Weapon
   respawn = true;
   behavior = "ChaseBehavior";
   maxRange = 25;
   minRange = 0;
   distDetect = 50;
   sidestepDist = 10;
   paceDist = 6;
   npcAction = 0;
   spawnGroup = 1;
   fov = 200;
   leash = 35;
   cycleCounter = "5";
   weaponMode = "pattern";
   activeDodge = 1;
   advancedDodge = "Random";
   team = 2;
   realName = "Tedi Bot";
   countRespawn = 0;
};

PlayerDatasGroup.add(TediPlayerData);