//-----------------------------------------------------------------------------
// Copyright (c) 2014 Packers Remakes
//-----------------------------------------------------------------------------

$flagslot = 2;

datablock ShapeBaseImageData(TediFlagImage)
{
   shapeFile = "art/shapes/flags/TediFlag.dae";
   item = Flag1;
   mountPoint = 2;
   offset = "0 0 0";
};

datablock ItemData(TediFlag)
{
   category = "Objectives";
   className = "Flag";
   image = Flag1Image;
   shapefile = "art/shapes/flags/TediFlag.dae";
   mass = 55;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 3;
   pickUpName = "a flag";
   computeCRC = true;

   isInvincible = true;
};

datablock ShapeBaseImageData(SquirrelFlagImage)
{
   shapeFile = "art/shapes/flags/SquirrelFlag.dae";
   item = Flag2;
   mountPoint = 2;
   offset = "0 0 0";

   lightType = "PulsingLight";
   lightColor = "0.5 0.5 0.5 1.0";
   lightTime = "1000";
   lightRadius = "3";
   cloakable = false;
};

datablock ItemData(SquirrelFlag)
{
   category = "Objectives";
   className = "Flag";
   image = Flag2Image;
   shapefile = "art/shapes/flags/SquirrelFlag.dae";
   mass = 55;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 3;
   pickUpName = "a flag";
   computeCRC = true;

   lightType = "PulsingLight";
   lightColor = "0.5 0.5 0.5 1.0";
   lightTime = "1000";
   lightRadius = "3";

   isInvincible = true;
};

/*

datablock ShapeBaseImageData(HeistBagImage)
{
   shapeFile = "art/shapes/flags/sphere.dts";
   item = Flag3;
   mountPoint = 2;
   offset = "0 0 0";

   lightType = "PulsingLight";
   lightColor = "0.5 0.5 0.5 1.0";
   lightTime = "1000";
   lightRadius = "3";
   cloakable = false;
};

datablock ItemData(HeistBag)
{
   category = "Objectives";
   className = "Flag";
   image = Flag3Image;
   shapefile = "art/shapes/flags/sphere.dts";
   mass = 55;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 3;
   pickUpName = "a flag";
   computeCRC = true;

   lightType = "PulsingLight";
   lightColor = "0.5 0.5 0.5 1.0";
   lightTime = "1000";
   lightRadius = "3";

   isInvincible = true;

};
*/

function Flag::onPickup(%this, %flag, %player, %amount)
{
   if (%player.getClassName() $= "Player" && %player.getMountedImage($FlagSlot) == 0) {
    	serverPlay3D(WeaponPickupSound,%flag.getTransform());
    	%player.incInventory(%this,1);
     	%player.mountImage(%this.image, $FlagSlot);
     	%flag.delete();
   }
}

function newflag(%flag,%player)
{
	echo("newflag" SPC %flag SPC %player);
	%obj = new Item() {
      dataBlock = %flag;
      static = false;
      rotate = false;
   };
   
   %obj.position=%player.position;
   MissionCleanup.add(%obj);
}