//-----------------------------------------------------------------------------
// Copyright (c) 2012 GarageGames, LLC
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
// IN THE SOFTWARE.
//-----------------------------------------------------------------------------

//--------------------------------------------------------------------------
// Sounds
//--------------------------------------------------------------------------

datablock SFXProfile(BazookaFireSound)
{
   filename = "art/sound/weapons/Bazooka_Fire";
   description = BulletFireDesc;
   preload = true;
};

datablock SFXProfile(BazookaReloadSound)
{
   filename = "art/sound/weapons/Weapon_reload";
   description = AudioClose3D;
   preload = true;
};

datablock SFXProfile(BazookaSwitchinSound)
{
   filename = "art/sound/weapons/Weapon_switch";
   description = AudioClose3D;
   preload = true;
};

datablock SFXProfile(BazookaImpactSound)
{
   filename = "art/sound/weapons/Bazooka_Hit";
   description = AudioClose3D;
   preload = true;
};

datablock SFXProfile(RocketBuzz1Sound)
{
   filename = "art/sound/weapons/RocketBuzz1";
   description = AudioClose3D;
   preload = true;
};

datablock SFXProfile(RocketBuzz2Sound)
{
   filename = "art/sound/weapons/RocketBuzz2";
   description = AudioClose3D;
   preload = true;
};

datablock SFXProfile(RocketBuzz3Sound)
{
   filename = "art/sound/weapons/RocketBuzz3";
   description = AudioClose3D;
   preload = true;
};

/*
datablock SFXPlayList(BazookaBuzz)
{
   description = "AudioCloseLoop3D";
   random = "StrictRandom";
   loopMode = "All";
   numSlotsToPlay = "3";
   
   isStreaming       = true;   
   
   track[0] = "RocketBuzz1Sound";
   track[1] = "RocketBuzz2Sound";
   track[2] = "RocketBuzz3Sound";
   trace = "0";
};
*/

// ----------------------------------------------------------------------------
// Particles
// ----------------------------------------------------------------------------
datablock ParticleData(BazookaFireSmoke)
{
   textureName          = "art/shapes/particles/smoke";
   dragCoefficient      = 0;
   gravityCoefficient   = -0.1;
   windCoefficient      = 0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 200;
   spinRandomMin = -180.0;
   spinRandomMax =  180.0;
   useInvAlpha   = true;

   colors[0]     = "0.8 0.8 0.8 0.7";
   colors[1]     = "0.87 0.87 0.87 0.35";
   colors[2]     = "0.9 0.84 0.8 0";

   sizes[0]      = 0.4;
   sizes[1]      = 1.2;
   sizes[2]      = 1.7;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(BazookaFireSmokeEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 10;
   ejectionVelocity = "4";
   velocityVariance = 1.0;
   thetaMin         = "0";
   thetaMax         = "0";
   lifetimeMS       = 250;
   particles = "RifleFireSmoke";
   blendStyle = "NORMAL";
   softParticles = "0";
   originalName = "RifleFireSmokeEmitter";
   alignParticles = "0";
   orientParticles = "0";
};

datablock ParticleData(RocketDirtDust)
{
   textureName          = "art/shapes/particles/impact.png";
   dragCoefficient      = 0;
   gravityCoefficient   = "-0.100122";
   windCoefficient      = 0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = "200";
   lifetimeVarianceMS   = "150";
   spinRandomMin = -180.0;
   spinRandomMax =  180.0;
   useInvAlpha   = true;

   colors[0]     = "0.996078 0.807843 0.00784314 0.685039";
   colors[1]     = "0.685039 0.606299 0.527559 0.346457";
   colors[2]     = "0.897638 0.84252 0.795276 0";

   sizes[0]      = "0.997986";
   sizes[1]      = "3.99805";
   sizes[2]      = "21.875";

   times[0]      = 0.0;
   times[1]      = "0.494118";
   times[2]      = 1.0;
   animTexName = "art/shapes/particles/impact.png";
   sizes[3] = "2";
   ejectionPeriodMS = "20";
   periodVarianceMS = "10";
   ejectionVelocity = "3";
   thetaMax = "180";
   particles = "BulletDirtDust";
   blendStyle = "NORMAL";
};

datablock ParticleEmitterData(RocketDirtDustEmitter)
{
   ejectionPeriodMS = "6";
   periodVarianceMS = "1";
   ejectionVelocity = 3.0;
   velocityVariance = 1.0;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = "0";
   particles = "RocketDirtDust";
   blendStyle = "NORMAL";
};

//-----------------------------------------------------------------------------
// Explosion
//-----------------------------------------------------------------------------
datablock ExplosionData(BazookaExplosion)
{
   soundProfile = BazookaImpactSound;
   lifeTimeMS = 165;

   // Volume particles
   particleEmitter = RocketDirtDustEmitter;
   particleDensity = 4;
   particleRadius = 0.3;

   // Point emission
   emitter[0] = BulletDirtSprayEmitter;
   emitter[1] = BulletDirtSprayEmitter;
   emitter[2] = BulletDirtRocksEmitter;
};
//--------------------------------------------------------------------------
// Shell ejected during reload.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Projectile Object
//-----------------------------------------------------------------------------

datablock ProjectileData( BazookaProjectile )
{
   projectileShapeName = "art/shapes/weapons/Bazooka/rocket.dae";

   directDamage        = 60;
   radiusDamage        = 30;
   damageRadius        = 5;
   areaImpulse         = 1500;
   impactForce         = 20000;

   explosion           = BazookaExplosion;
   decal               = ScorchRXDecal;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 8000;
   fadeDelay           = "5056";
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod          = 1;
   sound = "RocketBuzz1Sound";
};

//-----------------------------------------------------------------------------
// Ammo Item
//-----------------------------------------------------------------------------
datablock ItemData(BazookaClip)
{
   // Mission editor category
   category = "AmmoClip";

   // Add the Ammo namespace as a parent.  The ammo namespace provides
   // common ammo related functions and hooks into the inventory system.
   className = "AmmoClip";

   // Basic Item properties
   shapeFile = "art/shapes/weapons/Bazooka/Bazooka.DAE";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;

   // Dynamic properties defined by the scripts
   pickUpName = "Bazooka clip";
   count = 1;
   maxInventory = 1;
   
   //Set the max distance a bot will fire this weapon from
   ignoreDistance = 50;
   //Set the min distance a bot will fire this weapon from
   minIgnoreDistance = 0;
   //Set if this weapon uses ammo or not
   usesAmmo = true;
   //Sets how long the bot waits between firing bursts
   fireDelay = 1000;
   //Sets how long the bot holds down the trigger when firing. Use longer pulses for spray and pray type weapons.
   triggerDown = 500;
   //Sets the relative quality score of the weapon, how good is the weapon?
   //This should be set to a different value for every weapon.
   weapRating = 1;
   //The amount of ammo that bots using this weapon should start with.
   weapStartAmmo = 1;
   //Enemies using this weapon are unable to aim or move while firing it.
   notAim = true;
};

datablock ItemData(BazookaAmmo)
{
   // Mission editor category
   category = "Ammo";

   // Add the Ammo namespace as a parent.  The ammo namespace provides
   // common ammo related functions and hooks into the inventory system.
   className = "Ammo";

   // Basic Item properties
   shapeFile = "art/shapes/weapons/Bazooka/Bazooka.DAE";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;

   // Dynamic properties defined by the scripts
   pickUpName = "Bazooka Rocket";
   maxInventory = 1;
   clip = BazookaClip;
};

//--------------------------------------------------------------------------
// Weapon Item.  This is the item that exists in the world, i.e. when it's
// been dropped, thrown or is acting as re-spawnable item.  When the weapon
// is mounted onto a shape, the SoldierWeaponImage is used.
//-----------------------------------------------------------------------------
datablock ItemData(Bazooka)
{
   // Mission editor category
   category = "Weapon";

   // Hook into Item Weapon class hierarchy. The weapon namespace
   // provides common weapon handling functions in addition to hooks
   // into the inventory system.

   // Basic Item properties
   shapeFile = "art/shapes/weapons/Bazooka/Bazooka.DAE";
   mass = 1;
   elasticity = "0.199413";
   friction = "0.599218";
   emap = 1;

   // Dynamic properties defined by the scripts
   pickUpName = "Bazooka";
   description = "Bazooka";
   image = BazookaWeaponImage;
   
   // weaponHUD
   PreviewImage = 'Bazooka.png';
   reticle = 'blank';
   zoomReticle = 'bino';
   zoomReticleCrosshire = 'reticle_bazooka';
   cameraMaxDist = "0.892997";
   firstPersonOnly = "1";
   class = "Weapon";
   useEyePoint = "1";
};


datablock ShapeBaseImageData(BazookaWeaponImage)
{
   // Basic Item properties
   shapeFile = "art/shapes/weapons/Bazooka/Bazooka.DAE";
   shapeFileFP = "art/shapes/weapons/EmptyWeapon.DAE";
   emap = true;
   
   customZoom = 65.0; 

   imageAnimPrefix = "Bazooka";
   //imageAnimPrefixFP = "Bazooka";

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   firstPerson = false;
   useEyeNode = true;
   animateOnServer = true;
   eyeOffset = "0 0 -0.05";
   //Offset = "0.1 0.1 3";
   
   jumpingDisallowed = true;
   sprintDisallowed = true;
   crouchDisallowed = true;
   proneDisallowed = true;
   swimmingDisallowed = true;
   

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   class = "WeaponImage";
   className = "WeaponImage";

   // Projectiles and Ammo.
   item = Bazooka;
   ammo = BazookaAmmo;
   clip = BazookaClip;

   projectile = BazookaProjectile;
   projectileType = Projectile;
   projectileSpread = "0.001";

   //altProjectile = GrenadeLauncherProjectile;
   //altProjectileSpread = "0.02";

   //casing = BulletShell;
   //shellExitDir        = "1.0 0.3 1.0";
   //shellExitOffset     = "0.15 -0.56 -0.1";
   //shellExitVariance   = 15.0;
   //shellVelocity       = 3.0;

   // Weapon lights up while firing
   lightType = "WeaponFireLight";
   lightColor = "0.992126 0.968504 0.700787 1";
   lightRadius = "4";
   lightDuration = "100";
   lightBrightness = 2;

   // Shake camera while firing.
   shakeCamera = false;
   camShakeFreq = "2 2 2";
   camShakeAmp = "0.1 0.1 0.1";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   useRemainderDT = true;

   // Initial start up state
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   //stateTransitionOnNoAmmo[0]       = "NoAmmo";

   // Activating the gun.  Called when the weapon is first
   // mounted and there is ammo.
   stateName[1]                     = "Activate";
   stateTransitionGeneric0In[1]     = "SprintEnter";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 1;
   stateSequence[1]                 = "switch_in";
   stateSound[1]                    = BazookaSwitchinSound;

   // Ready to fire, just waiting for the trigger
   stateName[2]                     = "Ready";
   stateTransitionGeneric0In[2]     = "SprintEnter";
   stateTransitionOnMotion[2]       = "ReadyMotion";
   stateScaleAnimation[2]           = false;
   stateScaleAnimationFP[2]         = false;
   //stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSequence[2]                 = "idle";

   // Ready to fire with player moving
   stateName[3]                     = "ReadyMotion";
   stateTransitionGeneric0In[3]     = "SprintEnter";
   stateTransitionOnNoMotion[3]     = "Ready";
   stateWaitForTimeout[3]           = false;
   stateScaleAnimation[3]           = false;
   stateScaleAnimationFP[3]         = false;
   stateSequenceTransitionIn[3]     = true;
   stateSequenceTransitionOut[3]    = true;
   //stateTransitionOnNoAmmo[3]       = "NoAmmo";
   stateTransitionOnTriggerDown[3]  = "Fire";
   stateSequence[3]                 = "run";

   // Fire the weapon. Calls the fire script which does
   // the actual work.
   stateName[4]                     = "Fire";
   stateTransitionGeneric0In[4]     = "SprintEnter";
   stateTransitionOnTimeout[4]      = "WaitForRelease";
   stateTimeoutValue[4]             = 2;
   stateWaitForTimeout[4]           = true;
   stateFire[4]                     = true;
   stateRecoil[4]                   = "HeavyRecoil";
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "fire";
   stateScaleAnimation[4]           = true;
   stateSequenceNeverTransition[4]  = true;
   stateSequenceRandomFlash[4]      = true;        // use muzzle flash sequence
   stateScript[4]                   = "onFire";
   stateEmitter[4]                  = GunFireSmokeEmitter;
   stateEmitterTime[4]              = 0.025;
   stateEjectShell[4]               = true;
   stateSound[4]                    = BazookaFireSound;

   // Wait for the player to release the trigger
   stateName[5]                     = "WaitForRelease";
   stateTransitionGeneric0In[5]     = "SprintEnter";
   stateTransitionOnTriggerUp[5]    = "NewRound";
   stateTimeoutValue[5]             = 0.05;
   stateWaitForTimeout[5]           = true;
   stateAllowImageChange[5]         = false;

   // Put another round in the chamber
   stateName[6]                     = "NewRound";
   stateTransitionGeneric0In[6]     = "SprintEnter";
   //stateTransitionOnNoAmmo[6]       = "NoAmmo";
   stateTransitionOnTimeout[6]      = "Ready";
   stateWaitForTimeout[6]           = "0";
   stateTimeoutValue[6]             = 2;
   stateAllowImageChange[6]         = false;

   // No ammo in the weapon, just idle until something
   // shows up. Play the dry fire sound if the trigger is
   // pulled.

   // Play the reload clip animation
   stateName[7]                     = "ReloadClip";
   stateTransitionGeneric0In[7]     = "SprintEnter";
   stateTransitionOnTimeout[7]      = "Ready";
   stateWaitForTimeout[7]           = true;
   stateTimeoutValue[7]             = 8.0;
   stateReload[7]                   = true;
   stateSequence[7]                 = "reload";
   stateShapeSequence[7]            = "Reload";
   stateScaleShapeSequence[7]       = true;
   stateSound[7]                    = BazookaReloadSound;

   // Start Sprinting
   stateName[8]                    = "SprintEnter";
   stateTransitionGeneric0Out[8]   = "SprintExit";
   stateTransitionOnTimeout[8]     = "Sprinting";
   stateWaitForTimeout[8]          = false;
   stateTimeoutValue[8]            = 0.5;
   stateWaitForTimeout[8]          = false;
   stateScaleAnimation[8]          = false;
   stateScaleAnimationFP[8]        = false;
   stateSequenceTransitionIn[8]    = true;
   stateSequenceTransitionOut[8]   = true;
   stateAllowImageChange[8]        = false;
   stateSequence[8]                = "sprint";

   // Sprinting
   stateName[9]                    = "Sprinting";
   stateTransitionGeneric0Out[9]   = "SprintExit";
   stateWaitForTimeout[9]          = false;
   stateScaleAnimation[9]          = false;
   stateScaleAnimationFP[9]        = false;
   stateSequenceTransitionIn[9]    = true;
   stateSequenceTransitionOut[9]   = true;
   stateAllowImageChange[9]        = false;
   stateSequence[9]                = "sprint";
   
   // Stop Sprinting
   stateName[10]                    = "SprintExit";
   stateTransitionGeneric0In[10]    = "SprintEnter";
   stateTransitionOnTimeout[10]     = "Ready";
   stateWaitForTimeout[10]          = false;
   stateTimeoutValue[10]            = 0.5;
   stateSequenceTransitionIn[10]    = true;
   stateSequenceTransitionOut[10]   = true;
   stateAllowImageChange[10]        = false;
   stateSequence[10]                = "sprint";
};
