// Sound!
datablock SFXProfile(BulletImpact1Sound)
{
   filename = "art/sound/weapons/Bullet_hit1";
   description = AudioClose3D;
   preload = true;
};

datablock SFXProfile(BulletImpact2Sound)
{
   filename = "art/sound/weapons/Bullet_hit2";
   description = AudioClose3D;
   preload = true;
};

datablock SFXProfile(BulletImpact3Sound)
{
   filename = "art/sound/weapons/Bullet_hit3";
   description = AudioClose3D;
   preload = true;
};

datablock SFXProfile(BulletImpact4Sound)
{
   filename = "art/sound/weapons/Bullet_hit4";
   description = AudioClose3D;
   preload = true;
};

datablock SFXPlayList(BulletImpactList)
{
   description = "AudioClose3D";
   random = "StrictRandom";
   loopMode = "Single";
   numSlotsToPlay = "1";
   
   isStreaming       = true;   
   
   track[0] = "BulletImpact1Sound";
   track[1] = "BulletImpact2Sound";
   track[2] = "BulletImpact3Sound";
   track[3] = "BulletImpact4Sound";
   trace = "0";
};


datablock SFXProfile(BulletBuzz1Sound)
{
   filename = "art/sound/weapons/Bullet_Buzz1";
   description = AudioCloseLoop3D;
   preload = true;
};

datablock SFXProfile(BulletBuzz2Sound)
{
   filename = "art/sound/weapons/Bullet_Buzz2";
   description = AudioCloseLoop3D;
   preload = true;
};

datablock SFXProfile(BulletBuzz3Sound)
{
   filename = "art/sound/weapons/Bullet_Buzz3";
   description = AudioCloseLoop3D;
   preload = true;
};

datablock SFXProfile(BulletBuzz4Sound)
{
   filename = "art/sound/weapons/Bullet_Buzz4";
   description = AudioCloseLoop3D;
   preload = true;
};

//Uzi
datablock SFXProfile(BulletBuzz5Sound)
{
   filename = "art/sound/weapons/Bullet_Buzz5";
   description = AudioCloseLoop3D;
   preload = true;
};

/*

datablock SFXPlayList(BulletBuzz)
{
   description = "AudioCloseLoop3D";
   random = "StrictRandom";
   loopMode = "All";
   numSlotsToPlay = "5";
   
   isStreaming       = true;   
   
   track[0] = "BulletBuzz1Sound";
   track[1] = "BulletBuzz2Sound";
   track[2] = "BulletBuzz3Sound";
   track[3] = "BulletBuzz4Sound";
   track[4] = "BulletBuzz5Sound";
   trace = "0";
};
*/

// ----------------------------------------------------------------------------
// Particles
// ----------------------------------------------------------------------------
datablock ParticleData(RifleFireSmoke)
{
   textureName          = "art/shapes/particles/smoke";
   dragCoefficient      = 0;
   gravityCoefficient   = -0.1;
   windCoefficient      = 0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 200;
   spinRandomMin = -180.0;
   spinRandomMax =  180.0;
   useInvAlpha   = true;

   colors[0]     = "0.8 0.8 0.8 0.7";
   colors[1]     = "0.87 0.87 0.87 0.35";
   colors[2]     = "0.9 0.84 0.8 0";

   sizes[0]      = 0.4;
   sizes[1]      = 1.2;
   sizes[2]      = 1.7;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(RifleFireSmokeEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 10;
   ejectionVelocity = "4";
   velocityVariance = 1.0;
   thetaMin         = "0";
   thetaMax         = "0";
   lifetimeMS       = 250;
   particles = "RifleFireSmoke";
   blendStyle = "NORMAL";
   softParticles = "0";
   originalName = "RifleFireSmokeEmitter";
   alignParticles = "0";
   orientParticles = "0";
};

datablock ParticleData(BulletDirtDust)
{
   textureName          = "art/shapes/particles/impact";
   dragCoefficient      = 0;
   gravityCoefficient   = "-0.100122";
   windCoefficient      = 0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = "100";
   lifetimeVarianceMS   = "99";
   spinRandomMin = -180.0;
   spinRandomMax =  180.0;
   useInvAlpha   = true;

   colors[0]     = "0.496063 0.393701 0.299213 0.692913";
   colors[1]     = "0.692913 0.614173 0.535433 0.346457";
   colors[2]     = "0.897638 0.84252 0.795276 0";

   sizes[0]      = "1";
   sizes[1]      = "4";
   sizes[2]      = "6";

   times[0]      = 0.0;
   times[1]      = 1;
   times[2]      = 2.0;
   animTexName = "art/shapes/particles/impact";
   sizes[3] = "2";
   ejectionPeriodMS = "20";
   periodVarianceMS = "10";
   ejectionVelocity = "3";
   thetaMax = "180";
   particles = "BulletDirtDust";
   blendStyle = "NORMAL";
};

datablock ParticleEmitterData(BulletDirtDustEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 10;
   ejectionVelocity = 3.0;
   velocityVariance = 1.0;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = "0";
   particles = "BulletDirtDust";
   blendStyle = "NORMAL";
};

//-----------------------------------------------------------------------------
// Explosion
//-----------------------------------------------------------------------------
datablock ExplosionData(BulletDirtExplosion)
{
   soundProfile = BulletImpactList;
   lifeTimeMS = 75;

   // Volume particles
   particleEmitter = BulletDirtDustEmitter;
   particleDensity = 4;
   particleRadius = 0.3;

   // Point emission
   emitter[0] = BulletDirtSprayEmitter;
   emitter[1] = BulletDirtSprayEmitter;
   emitter[2] = BulletDirtRocksEmitter;
};

//--------------------------------------------------------------------------
// Shell ejected during reload.
//-----------------------------------------------------------------------------
datablock DebrisData(BulletShell)
{
   shapeFile = "art/shapes/weapons/misc/bulletShell.dae";
   lifetime = 6.0;
   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;
   elasticity = 0.65;
   friction = 0.05;
   numBounces = 5;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   ignoreWater = true;
   fade = true;
};

//-----------------------------------------------------------------------------
// Projectile Object
//-----------------------------------------------------------------------------
datablock LightDescription( BulletProjectileLightDesc )
{
   color  = "0.0 0.5 0.7";
   range = 3.0;
};

datablock ProjectileData( BulletProjectile )
{
   projectileShapeName = "art/shapes/weapons/misc/bullet.dts";

   directDamage        = 8;
   radiusDamage        = 0;
   damageRadius        = 0.5;
   areaImpulse         = 0.5;
   impactForce         = 1;

   explosion           = BulletDirtExplosion;
   decal               = BulletHoleDecal;

   muzzleVelocity      = 120;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = "2976";
   fadeDelay           = 1472;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod          = 1;
   
   sound = "BulletBuzz2Sound";
};